function [rand_paths, mean_path, total_sec, R] ...
    = grp(gpInputs, pnts, testInputs, kfun, nr_path)
%
% GAUSSIAN RANDOM PATH (GRP)
%

% 1. ANCHORING POINTS 
iclk     = clock;
nr_pnt   = size(pnts, 1);
dim      = size(pnts, 2);
output   = pnts;
mean_output = mean(output);
mz_output = output - repmat(mean_output, nr_pnt, 1);

% COMPUTE MEAN AND COVARIANCE FUNCTION 
k_TS      = kfun(testInputs, gpInputs);
K_TT      = kfun(testInputs, testInputs);
K_SS      = kfun(gpInputs, gpInputs) + 1E-5*eye(size(gpInputs, 1));
mean_path = k_TS/K_SS*mz_output + repmat(mean_output, length(testInputs), 1);
cov_path  = K_TT - k_TS/K_SS*k_TS'+ 1E-10*eye(length(testInputs));

% SAMPLE FOR GRP : N(mean_path, cov_path)
len_path = length(testInputs);
R    = cov_path;
R    = (R+R')/2;
cR   = chol(R); 
Rmtx = randn(dim*nr_path, len_path);
rand_paths = repmat(mean_path', nr_path, 1);
rand_paths = rand_paths + Rmtx*cR;



total_sec  = etime(clock, iclk)*1000;



